//   RW Sysutils
// ================
// ______
// -The RW Foundational Libraries

// Filename: ./include/rw/util/utility.hpp
// -Declarations of some baseline RW Sysutils features

#pragma once

#include "incls_all.hpp"

namespace rw::util {

//------------------------------------------------------------------------------
/** Our alias for value returned by various string member functions, on failure
 * @note: aka @a 'npos'
 */
constexpr auto str_end = std::string::npos;

//------------------------------------------------------------------------------
/** Convert all alphabetic characters of @a in_out to lowercase, in-place
 * @param[in/out] in_out the @c std::string to convert
 */
void to_lower(std::string& in_out);

//------------------------------------------------------------------------------
/** Determine if @a ss is empty
 * @param[in] ss @c std::stringstream to check
 * @return true if @a ss is empty, false otherwise
 */
auto is_empty(std::basic_stringstream<char>& ss) -> bool;

//------------------------------------------------------------------------------
/** Determine if @a file is empty
 * @param[in] file @c std::fstream to check
 * @return true if @a file is empty, false otherwise
 */
auto is_empty(std::basic_fstream<char>& file) -> bool;

//------------------------------------------------------------------------------
/** Parse @a strm with @c std::getline(), push lines onto @c vector<string>
 * @param[in] strm @c std::stringstream to parse
 * @return now-populated @c vector<string>
 */
auto strmlines_2_vec(std::basic_stringstream<char>& strm)
    -> std::vector<std::string>;

//------------------------------------------------------------------------------
/** Parse @a strm with @c std::getline(), push lines onto @c vector<string>
 * @param[in] strm @c std::fstream to parse
 * @return now-populated @c vector<string>
 */
auto strmlines_2_vec(std::basic_fstream<char>& strm)
    -> std::vector<std::string>;

}  // namespace rw::util

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v220122
// Copyright (2022)
// License MIT(Expat) https://opensource.org/licenses/MIT
