// RW Bumpmaster Project
// =====================
// Imageboard downloader + archiver demo project;  SAVE.EVERYTHING.ANON. :^)

// Filename: ./main_bumpmaster.cpp
// -The program's entry point

#include "incls_all.hpp"

void diag_bumpmaster(Bumpmaster const& bump);
bool is_test_tag(std::string const& tag);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\nSAVE.EVERYTHING.ANON. :^)\n");

  Bumpmaster bump{"bumpmaster"};
  diag_bumpmaster(bump);

  // TEMP: TEST: check on specified tags, within both styles of header returns
  // -specified tags to check for : 'expires', 'last-modified', 'content-length'

  // string const test_uri{"example.com"};
  string const test_uri{
      "https://alogs.theguntretort.com/robowaifu/catalog.json"};

  puts("\n\n     --=^=--\n\n");
  //--------
  auto hdr_A = bump.dolldrop().pull_w_hdr(test_uri);
  if (! is_empty(hdr_A)) {  //

    auto const ht = strmlines_2_vec(hdr_A);
    for (auto const& t : ht) {  // checks all header tags
      if (is_test_tag(t)) {
        cout << '\t' << t << '\n';
      }
    }

  } else
    cout << "hdr_A empty\n";

  puts("\n\n     --=^=--\n\n");
  //--------
  auto hdr_B = bump.dolldrop().pull_hdr(test_uri);
  if (! is_empty(hdr_B)) {  //

    auto const ht = strmlines_2_vec(hdr_B);
    for (auto const& t : ht) {  // checks all header tags
      if (is_test_tag(t)) {
        cout << '\t' << t << '\n';
      }
    }

  } else
    cout << "hdr_B empty\n";

  puts("\n\n     --=^=--\n\n");
  // --------
  // if (use_stamps)
  //   analyze_callgraph();

  puts("\n...leaving main()\n");

} catch (runtime_error const& e) {
  cerr << "\n  runtime_error '" << e.what() << "' caught in main()\n\n";

} catch (exception const& e) {
  cerr << "\n  exception '" << e.what() << "' caught in main()\n\n";

} catch (...) {
  cerr << "\n  unknown error caught in main()\n\n";
}

//------------------------------------------------------------------------------
/**
 * @param bump
 */
void diag_bumpmaster(Bumpmaster const& bump) {  //

  prt_tag(bump.t(), "bump");
  prt_tag(bump.board().t(), "bump.board()");
  prt_tag(bump.catalog().t(), "bump.catalog()");
  prt_tag(bump.page().t(), "bump.page()");
  prt_tag(bump.post().t(), "bump.post()");
  prt_tag(bump.site().t(), "bump.site()");
  prt_tag(bump.thread().t(), "bump.thread()");
  prt_tag(bump.waifusearch().t(), "bump.waifusearch()");
  //
  prt_tag(bump.dolldrop().t(), "bump.dolldrop()");
}

//------------------------------------------------------------------------------
/** Searches for one of a few specified text strings within this header tag
 * @param t @c std::string tag to search through
 * @return true if search term is found in @a t
 * @note: currently searches for 'expires', 'last-modified', 'content-length'
 */
bool is_test_tag(std::string const& t) {
  // 1st, mk cp for lowercase'd searches
  auto lct{t};
  to_lower(lct);

  // only use lowercased'd tags
  vector<string> const test_tags{"expires", "last-modified", "content-length"};
  //
  for (auto const& tag : test_tags) {
    if (lct.find(tag) != str_end)  // we found a test tag
      return true;
  }

  return false;  // if we're here, we didn't
}

//    --=^=--

// "Everyone's talking about IT & the Internet, and how advanced it's getting."

// rw_bumpmaster_demo.v220122
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
